#ifndef CSM_H
#define CSM_H
/* $Id: csm.h,v 1.12 1993/02/24 17:22:19 tony Exp $ */
/* Copyright 1989, The Regents of the University of Colorado
 * Permission is granted to use any portion of this file for any purpose,
 * commercial or otherwise, provided that this notice remains unchanged.
 */

#include <stdio.h>
#include "obstack.h"

	/* Variables exported by the Character Storage Module */

extern char **string;			/* Pointers to the stored strings */
extern int numstr;			/* Number of strings stored */
extern struct obstack csm_obstack;	/* String data storage */


	/* Macros defined by the Character Storage Module */

#define String(i) (string[i])
#define Csm_obstk (&csm_obstack)
#define NoStr 	  0


	/* Routines exported by the Character Storage Module */


#if defined(__cplusplus) || defined(__STDC__)
extern char * prtstcon(FILE *d, char *p);
#else
extern char * prtstcon(/* FILE *d; char *p; */);
#endif
/* Print a sequence of characters as a string constant without quotes
 *    On exit-
 *       The string pointed to by p has been added to the current
 *          line of d as a string constant without quotes
 *       prtstcon addresses the character following the terminator
 ***/


#if defined(__cplusplus) || defined(__STDC__)
extern void savestr(FILE *d);
#else
extern void savestr(/* FILE *d; */);
#endif
/* Save the current string table state
 *    On exit-
 *       File d is a symbolic encoding of the current state, suitable
 *          for inclusion in the string table module
 ***/


#if defined(__cplusplus) || defined(__STDC__)
extern void dmpstr(FILE *d);
#else
extern void dmpstr(/* FILE *d; */);
#endif
/* Dump the string table
 *    On exit-
 *       The string table contents have been written to d
 ***/


#if defined(__cplusplus) || defined(__STDC__)
extern int stostr(char *c, int l);
#else
extern int stostr(/* char *c; int l; */);
#endif
/* Store a string in the string table
 *    On entry-
 *       c points to the string to be stored
 *       l>0 = length of the string to be stored
 *    On exit-
 *       stostr=string table index of the stored string
 ***/

#endif
